<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPractice".
 *
 * Columns in table "provider_practice" available as properties of the model,
 * followed by relations of table "provider_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $primary_location
 * @property string $phone_number
 * @property string $fax_number
 * @property string $email
 * @property string $rank_order
 * @property string $location_details
 *
 * @property Practice $practice
 * @property Provider $provider
 * @property ProviderPracticeLocation[] $providerPracticeLocations
 * @property ProviderPracticeLocation[] $providerPracticeLocations1
 * @property ProviderPracticeSchedule[] $providerPracticeSchedules
 */
abstract class BaseProviderPractice extends BaseModel
{

    /**
     * This var is used to hold
     * CONCAT(p.prefix, ' ', p.first_name, ' ', p.last_name, ' at ', p2.name) AS provider_at_practice
     * @see practiceSchedule.php #31
     * @var string
     */
    public $provider_at_practice;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice';
    }

    public static function representingColumn()
    {
        return 'provider_id';
    }

    public function rules()
    {
        return array(
            array('provider_id, practice_id', 'required'),
            array('provider_id, practice_id, primary_location, rank_order', 'numerical', 'integerOnly' => true),
            array('phone_number, fax_number', 'length', 'max' => 14),
            array('email', 'length', 'max' => 254),
            array('location_details', 'length', 'max' => 50),
            array('email', 'email'),
            array('primary_location, rank_order, location_details', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, provider_id, practice_id, primary_location, phone_number, fax_number, email, location_details',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'providerPracticeLocations' => array(self::HAS_MANY, 'ProviderPracticeLocation', 'provider_id'),
            'providerPracticeLocations1' => array(self::HAS_MANY, 'ProviderPracticeLocation', 'practice_id'),
            'providerPracticeSchedules' => array(self::HAS_MANY, 'ProviderPracticeSchedule', 'provider_practice_id'),
            'clientProvider' => array(self::BELONGS_TO, 'clientProvider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'practice_id' => Yii::t('app', 'Practice'),
            'primary_location' => Yii::t('app', 'Is Primary Location?'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'fax_number' => Yii::t('app', 'Fax Number'),
            'email' => Yii::t('app', 'Email Address'),
            'rank_order' => Yii::t('app', 'Rank Order'),
            'location_details' => Yii::t('app', 'Location Details'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //don't enable eager loading here!
//        $criteria->compare('id', $this->id);
        //$criteria->compare('provider.first_last', $this->provider_id, true);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        //$criteria->compare('practice.name', $this->practice_id, true);
        //it will search by id or provider.first_last
        if (!intval($this->practice_id) && is_string($this->practice_id) && strlen($this->practice_id) > 0) {
            $criteria->with[] = 'practice';
            $criteria->addSearchCondition("practice.name", $this->practice_id);
        } else {
            $criteria->compare('practice_id', $this->practice_id);
        }
        $criteria->compare('primary_location', $this->primary_location);
        $criteria->compare('t.rank_order', $this->rank_order);
        $criteria->compare('t.phone_number', $this->phone_number, true);
        $criteria->compare('t.fax_number', $this->fax_number, true);
        $criteria->compare('t.email', $this->email, true);
        $criteria->compare('location_details', $this->location_details, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPractice|ProviderPractices', $n);
    }

}
